﻿using Syncfusion.SfDataGrid.XForms.DataPager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.SfDataGrid.XForms;
using Syncfusion.Data;
using System.Reflection;
using System.Globalization;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace DataGridDemo
{
    public partial class MainPage : ContentPage
    {
        private static ObservableCollection<FoodProperty> samples = new ObservableCollection<FoodProperty>();

        private SfDataGrid sfData = new SfDataGrid();
        public MainPage()
        {
            samples = new ObservableCollection<FoodProperty>

    {

      new FoodProperty{ Flag = true, Id = "06061", Name = "Cabbage", Weight = 12.3 },

        new FoodProperty{ Flag = true, Id = "06153", Name = "Onions" , Weight = 23.4},

        new FoodProperty{ Flag = true, Id = "06182", Name = "Tomatoes", Weight = 34.5 },

        new FoodProperty{ Flag = true, Id = "06212", Name = "Carrot", Weight = 45.6 },

        new FoodProperty{ Flag = true, Id = "06263", Name = "Broccoli", Weight = 56.7 },

    };


            InitializeComponent();
            sfData.ItemsSource = samples;


            // Probably the problem lurks in this part.
            Style style = new Style(typeof(GridCell));
            style.Setters.Add(new Setter() { Property = GridCell.ForegroundProperty, Value = new Binding("Flag", BindingMode.Default, new StyleConverter()) });


            Trigger trg = new Trigger(typeof(GridCell));
            trg.Property = GridCell.ForegroundProperty;
            trg.Value = new Binding("Id", BindingMode.Default,new StyleConverter());
            style.Triggers.Add(trg);


            GridSwitchColumn gridSwitchColumn = new GridSwitchColumn();

            var switchass = new GridSwitchColumn()
            {
                MappingName = "Flag",
                HeaderText = "On/OFF",

                CellStyle = style

            };
            sfData.Columns.Add(switchass);
            

            sfData.Columns.Add(new GridTextColumn()

            {

                MappingName = "Id",

                HeaderText = "ID",

                CellStyle = style

            });

            sfData.Columns.Add(new GridTextColumn()

            {

                MappingName = "Name",

                HeaderText = "Name",

                CellStyle = style

            });

            Content = sfData;
            sfData.UnboundRows.Add(new GridUnboundRow() { Position = UnboundRowsPosition.FixedTop });
            sfData.GridLoaded += SfData_GridLoaded;
            sfData.QueryUnboundRow += SfData_QueryUnboundRow; ;
            
        }

        private void SfData_GridLoaded(object sender, GridLoadedEventArgs e)
        {
            sfData.ValueChanged += SfData_ValueChanged;
        }

        private void SfData_QueryUnboundRow(object sender, GridUnboundRowEventArgs e)
        {
            if(e.UnboundAction == UnboundActions.QueryData)
            {
                if(e.RowColumnIndex.ColumnIndex == 3)
                {
                    e.Value = samples.Where(x => x.Flag == true).Sum(x => x.Weight);
                    e.Handled = true;
                }
            }
        }

        private void SfData_ValueChanged(object sender, Syncfusion.SfDataGrid.XForms.ValueChangedEventArgs e)
        {
            if (e.NewValue != e.CellValue && e.RowColumnIndex.ColumnIndex == 0)
            {
                this.sfData.InvalidateUnboundRow(this.sfData.UnboundRows[0]);
            }
        }
        
    }



    internal class StyleConverter : IValueConverter

    {

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            bool _value = (bool)value;

            if (!_value)
            {
                
                return Color.Silver;

            }

            return Color.Black;

        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)

        {

            return value;

        }


    }



    public class FoodProperty : INotifyPropertyChanged

    {

        private bool flag;

        public string Id { set; get; }

        public string Name { set; get; }

        public double Weight { set; get; }



        public bool Flag

        {

            set

            {

                flag = value;

                RaisePropertyChanged("Flag");

            }

            get => flag;

        }


        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string Name)

        {

            if (PropertyChanged != null)

            {

                this.PropertyChanged(this, new PropertyChangedEventArgs(Name));

            }

        }

    }

    public class ExtendStyle : DataGridStyle
    {
        public override Color GetBorderColor()
        {
            return Color.Green;
        }

        public override Color GetCurrentCellBorderColor()
        {
            return GetBorderColor();
        }

    }
}
